package com.example.onlinejudge.judge.codesandbox;

import com.example.onlinejudge.judge.codesandbox.impl.ExampleCodeSandbox;
import com.example.onlinejudge.judge.codesandbox.impl.RemoteCodeSandbox;
import com.example.onlinejudge.judge.codesandbox.impl.ThirdPartyCodeSandbox;


/**
 * 代码沙箱工厂（根据字符串参数创建指定的代码沙箱实例）
 */
public class CodeSandboxFactory {

    public static CodeSandbox newInstance(String type){
        switch (type){
            case "example":
                System.out.println("示例代码沙箱");
                return new ExampleCodeSandbox();
            case "remote":
                System.out.println("远程代码沙箱");
                return new RemoteCodeSandbox();
            case "thirdParty":
                System.out.println("第三方代码沙箱");
                return new ThirdPartyCodeSandbox();
            default:
                System.out.println("默认代码沙箱");
                return new RemoteCodeSandbox();
        }
    }

}
