package com.example.onlinejudge.service.impl;

import cn.dev33.satoken.stp.StpUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.onlinejudge.model.VO.UserVO;
import com.example.onlinejudge.model.entity.User;
import com.example.onlinejudge.mapper.UserMapper;
import com.example.onlinejudge.common.result.Result;
import com.example.onlinejudge.common.result.ResultCode;
import com.example.onlinejudge.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;

/**
 * 实现用户服务
 */
@Service
public class UserServiceImpl implements UserService {
    @Autowired
    private UserMapper userMapper;

    @Override
    public Long getLoginUserId() {
        return StpUtil.getLoginIdAsLong();
    }

    @Override
    public Boolean isAdmin(Long userId) {
        return StpUtil.hasRole("admin");
    }

    /**
     * 用户登录服务
     *
     * @param username 用户名
     * @param password 密码
     * @return 登录结果
     */
    @Override
    public Result login(String username, String password) {
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("username", username).eq("password", password);
        User user = userMapper.selectOne(queryWrapper);
        if (user != null) {
            StpUtil.login(user.getId());
            return Result.success();
        }
        return Result.error(ResultCode.USER_LOGIN_ERROR);
    }

    @Override
    public User getLoginUser(HttpServletRequest request) {
        return userMapper.selectById(StpUtil.getLoginIdAsLong());
    }

    @Override
    public User getUserById(Long id) {
        return userMapper.selectById(id);
    }

    @Override
    public UserVO getUserVO(User user) {
        return null;
    }
}
